## med-fichier 4.1.0+repack

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.10 FATAL_ERROR)
PROJECT(MEDFile C CXX)

## The following signature is still buggy as of CMake 2.8.11 - 
## the OPTIONAL is not considered.
## See http://www.cmake.org/Bug/view.php?id=10227
#ENABLE_LANGUAGE(Fortran OPTIONAL)

INCLUDE(CheckLanguage)
CHECK_LANGUAGE(Fortran)
IF(CMAKE_Fortran_COMPILER)
  ENABLE_LANGUAGE(Fortran)
ELSE()
  MESSAGE(STATUS "No Fortran support")
ENDIF()

## Version number 
SET(MED_NUM_MAJEUR  4)
SET(MED_NUM_MINEUR  1)
SET(MED_NUM_RELEASE 0)

## Previous version
SET(MED_3_LATEST_MINOR 3)
SET(MED_40_LATEST_RELEASE 1)

SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

SET(MED_MEDINT_TYPE CACHE STRING "Use <int> or <long> C type for med_int (optional, be careful of the fortran default integer size)")
#EF : LONG_OR_INT n'était pas pris en compte car MED_CHECK_SIZE teste la taille de l'entier fortran
#     Lorsqu'il n'y a pas d'entier fortran la valeur par défaut était integer*4
# SET(LONG_OR_INT int)

## User options:
OPTION (MEDFILE_BUILD_TESTS "Build MED-file tests" ON)
IF (MEDFILE_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()
OPTION (MEDFILE_BUILD_SHARED_LIBS "Build MED-file shared libraries" ON)
OPTION (MEDFILE_BUILD_STATIC_LIBS "Build MED-file static libraries" OFF)
OPTION (MEDFILE_INSTALL_DOC "Install pre-built documentation" ON)
OPTION (MEDFILE_BUILD_PYTHON "Build Python bindings (needs SWIG)" OFF)
OPTION (MEDFILE_USE_UNICODE "Use unicode filenames" OFF)

#-- Add an Option to toggle the generation of the API documentation
#-- Embedded documentation contains generated fortran documentation produced with a patched Doxygen version
#-- If you rebuild it with your own doxygen, Fortran documentation will differ
option(MEDFILE_BUILD_DOC "Use Doxygen to create the HTML based API documentation" OFF)
if(MEDFILE_BUILD_DOC)
  FIND_PACKAGE(Doxygen)
  if (NOT DOXYGEN_FOUND)
    message(FATAL_ERROR
      "Doxygen is needed to build the documentation. Please install it correctly")
  endif()

  ADD_SUBDIRECTORY(doc)
endif()

IF(MEDFILE_USE_UNICODE)
  ADD_DEFINITIONS(-DUNICODE)
ENDIF()

# Option checking.
IF(MEDFILE_BUILD_SHARED_LIBS AND MEDFILE_BUILD_STATIC_LIBS)
  MESSAGE(FATAL_ERROR "You can not build shared and static libraries at the same time! ")
  SET(MEDFILE_BUILD_STATIC_LIBS OFF)
ENDIF()
IF(NOT (MEDFILE_BUILD_SHARED_LIBS OR MEDFILE_BUILD_STATIC_LIBS))
  MESSAGE(FATAL_ERROR "You must select to build either STATIC or SHARED libs")
  SET(MEDFILE_BUILD_SHARED_LIBS ON)
ENDIF()

## Useful macros
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake_files")
INCLUDE(medMacros)

## Version number
#MED_EXTRACT_AUTOTOOLS_VERSION(${PROJECT_SOURCE_DIR}/configure.ac MED_NUM_MAJEUR MED_NUM_MINEUR MED_NUM_RELEASE)
#SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

## Platform specific flags (windows)
IF(WIN32)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)  # To disable windows warnings for strcpy, fopen, ...
  ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)  # To disable windows warnings std::copy, std::transform, ...
  ADD_DEFINITIONS(-DWNT -DWIN32)
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500) # Windows 2000 or later API is required
  ADD_DEFINITIONS(-DPPRO_NT_CALL)        # For windows system functions call

  IF(NOT MINGW)
    # Needed to avoid a seg fault at runtime!
    # The variable is not very well documented but seems to exist
    SET(CMAKE_Fortran_FLAGS  "/iface:mixed_str_len_arg ${CMAKE_Fortran_FLAGS}")
    ADD_DEFINITIONS(-DPPRO_NT) # For windows medfile function nammes
  ENDIF()

ELSE()
  # Ensure intermediate OBJECT libraries and static libs are built with -fPIC:
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF(WIN32)

## Directories
IF(WIN32 AND NOT CYGWIN)
   SET(INSTALL_CMAKE_CONFIG_DIR cmake)
ELSE()
   SET(INSTALL_CMAKE_CONFIG_DIR share/cmake/med-fichier-${MED_STR_VERSION})
ENDIF()
SET(INSTALL_INCLUDE_DIR include)

## Pre-requisites detection
# Detect HDF5 first to potentially retrieve MPI automatically:
MED_FIND_HDF5()
MED_FIND_MPI()

IF(MEDFILE_BUILD_PYTHON)
  FIND_PACKAGE(SWIG REQUIRED)
  INCLUDE(${SWIG_USE_FILE})
  FIND_PACKAGE(PythonLibs REQUIRED)
  FIND_PACKAGE(PythonInterp REQUIRED)  # to get version string ...
ENDIF()

## Creation of files med_config.h.cmake
MED_CREATE_CONFIG_FILES()

## Check for various functions
MED_CHECK_HEADERS()
MED_CHECK_FUNCTIONS()
MED_CHECK_SIZE()
MED_C_FORTRAN_INTERFACE()
MED_TIME_SYS_TIME()

## Configure the files created above
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/med_config.h")
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h")

## Sources 
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(tools)
IF(MEDFILE_BUILD_TESTS)
  ADD_SUBDIRECTORY(tests)
ENDIF()
IF(MEDFILE_BUILD_PYTHON)
  ADD_SUBDIRECTORY(python)
ENDIF()

## Installation of the doc
IF(MEDFILE_INSTALL_DOC  OR MEDFILE_BUILD_DOC)
  INSTALL(DIRECTORY doc/html.dox/ DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/med-fichier-${MED_STR_VERSION} REGEX "Makefile*" EXCLUDE PATTERN "*.am" EXCLUDE)
  INSTALL(DIRECTORY doc/gif doc/jpg doc/png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/med-fichier-${MED_STR_VERSION} FILES_MATCHING PATTERN "*.gif" PATTERN "*.jpg" PATTERN "*.svg" PATTERN "*.png")
ENDIF()

#######################
## Configuration export
#######################
INCLUDE(CMakePackageConfigHelpers)

# Project name, upper case
STRING(TOUPPER ${PROJECT_NAME} PROJECT_NAME_UC)

# Detect if we are built as a sub-project in a bigger source tree:
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
  SET(_BUILT_AS_SUB FALSE)
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} standalone.")
ELSE()
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} as a sub-project. No conf files will be installed.")
  SET(_BUILT_AS_SUB TRUE)
ENDIF()

# Add all targets to the build-tree export set if we are *not*  
# built as a sub-folder of a bigger project.
IF(NOT _BUILT_AS_SUB)
  IF(CMAKE_Fortran_COMPILER_WORKS)
    SET(_fortLib med medfwrap)
    SET(_fortLibS med_static medfwrap_static)
  ELSE()
    SET(_fortLib "")
    SET(_fortLibS "")
  ENDIF()
  
  IF(MEDFILE_BUILD_STATIC_LIBS)
    EXPORT(TARGETS medC_static ${_fortLibS}
      FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  IF(MEDFILE_BUILD_SHARED_LIBS) 
    EXPORT(TARGETS medC ${_fortLib}
      APPEND FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  
ENDIF()

# Create the configuration files:
#   - in the build tree:
SET(HDF5_ROOT_DIR "${HDF5_ROOT_DIR}")  # ensure the var exists, even if blank
SET(MPI_ROOT_DIR "${MPI_ROOT_DIR}")    # ensure the var exists, even if blank
SET(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include" "${PROJECT_BINARY_DIR}/include")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

#   - in the install tree:
#       Get the relative path of the include directory so 
#       we can register it in the generated configuration files:
SET(CONF_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

WRITE_BASIC_PACKAGE_VERSION_FILE(${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${MED_STR_VERSION}
    COMPATIBILITY AnyNewerVersion)
  
# Install the CMake configuration files:
INSTALL(FILES
  "${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}")

# Install the export set for use within the install-tree
IF(NOT _BUILT_AS_SUB)
  INSTALL(EXPORT medfileTargets DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}" FILE ${PROJECT_NAME}Targets.cmake)
ENDIF()

=== python/CMakeLists.txt ===
INCLUDE(${SWIG_USE_FILE})

INCLUDE_DIRECTORIES(
  ${PYTHON_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
  )

SET(_swig_files 
  medenum_module.i
  medenumtest_module.i
  medequivalence_module.i
  medfamily_module.i
  medfield_module.i
  medfile_module.i
  medfilter_module.i
  medinterp_module.i
  medlibrary_module.i
  medlink_module.i
  medlocalization_module.i
  medmesh_module.i
  medparameter_module.i
  medprofile_module.i
  medsubdomain_module.i
  medstructelement_module.i
)

IF(APPLE)
  SET(PYTHON_LIBRARIES "-undefined dynamic_lookup")
ENDIF(APPLE)

SET(_link_libs
  medC
  ${PYTHON_LIBRARIES}
  )

SET(_install_dir lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/med)

# Ensure we will be able to run the Python tests from the build tree by outputing
# files into the package folder:
SET(CMAKE_SWIG_OUTDIR med)
FILE(COPY "__init__.py" DESTINATION ${PROJECT_BINARY_DIR}/python/med)

FOREACH(f ${_swig_files})
  SET_SOURCE_FILES_PROPERTIES(${f} PROPERTIES CPLUSPLUS ON SWIG_FLAGS "-shadow")

  # Get module name
  STRING(REPLACE "_module.i" "" _module_name ${f})

  # SWIG source file and module name differ - the following needs to be
  # set to avoid unnecessary rebuilds:
  SET_SOURCE_FILES_PROPERTIES(${f} PROPERTIES SWIG_MODULE_NAME ${_module_name})

  SET(SWIG_MODULE_libbatch_EXTRA_DEPS ${SWIG_LB_DPYS})
#EF: (OLDWAY)  SWIG_ADD_MODULE(${_module_name} python ${f})
  SWIG_ADD_LIBRARY(${_module_name} TYPE MODULE LANGUAGE python SOURCES ${f})
  SWIG_LINK_LIBRARIES(${_module_name} ${_link_libs})

  INSTALL(TARGETS ${SWIG_MODULE_${_module_name}_REAL_NAME} DESTINATION ${_install_dir})
  INSTALL_AND_COMPILE_PYTHON_FILE("${CMAKE_CURRENT_BINARY_DIR}/med/${_module_name}.py" ${_install_dir})
  
ENDFOREACH()

INSTALL_AND_COMPILE_PYTHON_FILE("${CMAKE_CURRENT_SOURCE_DIR}/__init__.py" ${_install_dir})

=== src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS})

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targes built in the sub-directories:
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-DmedC_EXPORTS)
ENDIF()
  
# Specific include logic - see CMakeLists.txt inside:
ADD_SUBDIRECTORY("2.3.6")

# Important: the following include comes AFTER the subdirectory 2.3.6
# to ensure the include works properly (2.3.6 includes are specific)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include 
    ${PROJECT_SOURCE_DIR}/include)

# Get pure C intermediary targets:
ADD_SUBDIRECTORY(hdfi)
ADD_SUBDIRECTORY(ci)
ADD_SUBDIRECTORY(misc)

IF(CMAKE_Fortran_COMPILER_WORKS)
  # Build intermediate targets _cfi, _cfi_static and _fi:
  ADD_SUBDIRECTORY(cfi)
  ADD_SUBDIRECTORY(fi)

  SET(medfort_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236> 
    $<TARGET_OBJECTS:_cfi>
  )
  
  SET(medfort_static_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236_static> 
    $<TARGET_OBJECTS:_cfi_static>
  )
ENDIF()

SET(medC_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236>
  $<TARGET_OBJECTS:_hdfi236>
  $<TARGET_OBJECTS:_misc236>
  $<TARGET_OBJECTS:_med236>
  $<TARGET_OBJECTS:_ci>
  $<TARGET_OBJECTS:_misc>
  $<TARGET_OBJECTS:_hdfi>  
)

SET(medC_static_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236_static>
  $<TARGET_OBJECTS:_hdfi236_static>
  $<TARGET_OBJECTS:_misc236_static>
  $<TARGET_OBJECTS:_med236_static>
  $<TARGET_OBJECTS:_ci_static>
  $<TARGET_OBJECTS:_misc_static>
  $<TARGET_OBJECTS:_hdfi_static>  
)

########################### Pure C stuff ###################################
############################################################################

### Installation preparation:
SET(_export_group "medfileTargets")

######### Shared Libraries ##########
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medC SHARED ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC PROPERTIES
    SOVERSION 11
    VERSION   11.0.1)
  TARGET_LINK_LIBRARIES(medC ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC NOGDI)
  
  INSTALL(TARGETS medC EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})  
ENDIF()

######### Static Libraries ##########
##
## Target names are suffixed with "_static" but file 
## names remain the same.
 
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medC_static STATIC ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC_static PROPERTIES OUTPUT_NAME medC)
  TARGET_LINK_LIBRARIES(medC_static ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC_static NOGDI)
  
  INSTALL(TARGETS medC_static EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})
ENDIF()

########################### Fortran stuff ###################################
#############################################################################
IF(CMAKE_Fortran_COMPILER_WORKS)
  
  ######### Shared Libraries ##########
  IF(MEDFILE_BUILD_SHARED_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap SHARED ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap PROPERTIES
      SOVERSION 11
      VERSION   11.0.1)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    INSTALL(TARGETS medfwrap EXPORT medfileTargetsF DESTINATION lib${LIB_SUFFIX})

    # Add Shared MED library
    ADD_LIBRARY(med SHARED MEDiterators.c)
    SET_TARGET_PROPERTIES(med PROPERTIES
      SOVERSION 11
      VERSION   11.0.1)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    TARGET_LINK_LIBRARIES(med medfwrap)    
   
    # Install only the resulting library:
    INSTALL(TARGETS med EXPORT medTargetsF DESTINATION lib${LIB_SUFFIX})
  ENDIF()

  ######### Static Libraries ##########
  ##
  ## Target names are suffixed with "_static" but file 
  ## names remain the same.
  IF(MEDFILE_BUILD_STATIC_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap_static STATIC ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap_static PROPERTIES OUTPUT_NAME medfwrap)
    TARGET_LINK_LIBRARIES(medfwrap_static medC_static)
    INSTALL(TARGETS medfwrap_static EXPORT medfileTargetsF DESTINATION lib${LIB_SUFFIX})
    
    # Add Static MED library
    ADD_LIBRARY(med_static STATIC MEDiterators.c)
    SET_TARGET_PROPERTIES(med_static PROPERTIES OUTPUT_NAME med)
    TARGET_LINK_LIBRARIES(med_static medfwrap_static)

    # Install only the resulting library:  
    INSTALL(TARGETS med_static EXPORT medfileTargetsF DESTINATION lib${LIB_SUFFIX})
  ENDIF()
  
ENDIF(CMAKE_Fortran_COMPILER_WORKS)

=== tests/CMakeLists.txt ===
ADD_SUBDIRECTORY(c)
IF(CMAKE_Fortran_COMPILER_WORKS)
  ADD_SUBDIRECTORY(f)
ENDIF(CMAKE_Fortran_COMPILER_WORKS)
IF(MEDFILE_BUILD_PYTHON AND NOT WIN32)
  ADD_SUBDIRECTORY(python)
ENDIF()

=== tools/CMakeLists.txt ===
# Decide if the tools will use dynamic or static linking:
IF(MEDFILE_BUILD_SHARED_LIBS)
  SET(MEDFILE_ENGINE_LIB medC)
ELSE()
  ADD_DEFINITIONS(-DMED3_USESTATIC)
  SET(MEDFILE_ENGINE_LIB medC_static)
ENDIF()

# Definitions used in tools:
ADD_DEFINITIONS(-DMED_MESGERR_FOR_TOOLS)

ADD_SUBDIRECTORY(mdump)
ADD_SUBDIRECTORY(medconforme)
ADD_SUBDIRECTORY(medimport)

=== include/2.3.6/CMakeLists.txt ===
CONFIGURE_FILE(med.h.in ${CMAKE_CURRENT_BINARY_DIR}/med.h @ONLY)
CONFIGURE_FILE(med23v30.h.in ${CMAKE_CURRENT_BINARY_DIR}/med23v30.h @ONLY)
CONFIGURE_FILE(med_utils.h.in ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h @ONLY)


SET(med236C_HEADERS_H
  MEDerreur.hxx
  medC_win_dll.h
  ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h
  med23v30_proto.h
  ${CMAKE_CURRENT_BINARY_DIR}/med23v30.h
  med_exit_if.h
  ${CMAKE_CURRENT_BINARY_DIR}/med.h
  med_proto.h
)

SET(med236F_HEADERS_H
  med.hf
)

INSTALL(FILES ${med236C_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR}/2.3.6)
INSTALL(FILES ${med236F_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR}/2.3.6)

=== src/2.3.6/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
)
 
SET(med236_SOURCES MEDaffiche.c)

# Definitions
ADD_DEFINITIONS(-DMED_API_23)

# Include are specific for the 2.3.6 version - make sure they get incl first:
INCLUDE_DIRECTORIES(BEFORE 
    "${PROJECT_BINARY_DIR}/include/2.3.6"
    "${PROJECT_SOURCE_DIR}/include/2.3.6")

# Build intermediate targets _cfi236, _hdfi236, _misc236 and _ci236 
# (and their static counterpart):
ADD_SUBDIRECTORY(cfi)
ADD_SUBDIRECTORY(ci)
ADD_SUBDIRECTORY(hdfi)
ADD_SUBDIRECTORY(misc)

# Build intermediate Fortran target _fi236:
IF(CMAKE_Fortran_COMPILER_WORKS)
  ADD_SUBDIRECTORY(fi)
ENDIF()

# Intermediary target:
ADD_LIBRARY(_med236  OBJECT ${med236_SOURCES})

=== src/cfi/CMakeLists.txt ===
SET(cfi_SOURCES
  librarycf.c
  medlocalizationcf.c
  medprofilecf.c
  medinterpcf.c
  medlinkcf.c
  medequivalencecf.c
  medfieldcf.c
  meshcf.c
  medfamilycf.c
  medstructelementcf.c
  medsupportcf.c
  medjointcf.c
  medparametercf.c
  medfiltercf.c
  filecf.c
  MEDversionedApi3F.cxx
  )

IF(MEDFILE_USE_MPI)
  LIST(APPEND cfi_SOURCES parfilecf.c)
ENDIF(MEDFILE_USE_MPI)

ADD_DEFINITIONS(-DNOGDI)
  
# Intermediary target
ADD_LIBRARY(_cfi OBJECT ${cfi_SOURCES})

ADD_LIBRARY(_cfi_static OBJECT ${cfi_SOURCES})
MED_SET_DEFINITIONS(_cfi_static MED3_USESTATIC)

=== src/ci/CMakeLists.txt ===
SET(ci_SOURCES
MEDmeshEntityAttributeAdvancedWr.c 
MEDmeshEntityAttributeAdvancedRd.c 
MEDmeshGeotypeName.c 
MEDmeshGeotypeParameter.c 
MEDmeshNodeCoordinateTrsfWr.c 
MEDmeshNodeCoordinateTrsfRd.c 
MEDfieldInterpInfo.c 
MEDfieldnInterp.c 
MEDfieldInterpWr.c 
MEDinterpCr.c 
MEDinterpBaseFunctionWr.c 
MEDnInterp.c 
MEDinterpInfoByName.c 
MEDinterpInfo.c 
MEDinterpBaseFunctionRd.c 
MEDinterpBaseFunctionCoeffSize.c 
MEDlibraryNumVersion.c
MEDlibraryStrVersion.c
MEDlibraryHdfNumVersion.c
MEDlibraryHdfStrVersion.c
MEDlibraryClose.c
MEDfileExist.c
MEDfileOpen.c
MEDfileVersionOpen.c
MEDfileName.c
MEDmemFileOpen.c
MEDfileClose.c 
MEDfileCommentWr.c 
MEDfileCommentRd.c 
MEDfileCompatibility.c 
MEDfileNumVersionRd.c 
MEDfileStrVersionRd.c 
MEDfileObjectsMount.c 
MEDfileObjectsMountById.c 
MEDfileObjectsUnmount.c 
MEDfileObjectExist.c
MEDnProfile.c 
MEDprofileInfo.c 
MEDprofileWr.c 
MEDprofileSizeByName.c 
MEDprofileRd.c 
MEDfilterEntityCr.c 
MEDfilterBlockOfEntityCr.c 
_MEDfieldValueAdvancedWr30.c 
_MEDfieldValueAdvancedWr33.c 
MEDfieldValueAdvancedWr.c 
MEDfieldValueWithProfileWr.c 
MEDfieldValueWr.c 
_MEDfieldValueAdvancedRd30.c 
_MEDfieldValueAdvancedRd33.c 
_MEDfieldValueAdvancedRd236.c 
MEDfieldValueAdvancedRd.c 
MEDfieldValueWithProfileRd.c 
MEDfieldValueRd.c 
MEDfieldCr.c 
MEDnField.c 
MEDfieldnComponent.c 
MEDfieldnComponentByName.c 
MEDfieldInfo.c 
MEDfieldInfoByName.c 
MEDfieldComputingStepInfo.c 
MEDfieldComputingStepMeshInfo.c 
MEDfieldComputingStepMeshWr.c 
MEDfieldnProfile.c 
_MEDfieldnValue.c 
MEDfieldnValueWithProfileByName.c 
MEDfieldnValueWithProfile.c 
MEDfieldnValue.c 
MEDlocalizationWr.c 
MEDlocalizationRd.c 
MEDnLocalization.c 
MEDlocalizationInfo.c 
MEDlocalizationInfoByName.c 
MEDlinkWr.c 
MEDlinkRd.c 
MEDnLink.c 
MEDlinkInfoByName.c 
MEDlinkInfo.c 
_MEDmeshCr.c 
MEDmeshCr.c 
MEDsupportMeshCr.c 
_MEDmeshInfoByName.c 
MEDmeshInfoByName.c 
MEDsupportMeshInfoByName.c 
MEDmeshInfo.c 
MEDsupportMeshInfo.c 
MEDnMesh.c 
MEDnSupportMesh.c 
MEDsupportMeshnAxis.c 
MEDsupportMeshnAxisByName.c 
MEDmeshGridTypeWr.c 
MEDmeshGridTypeRd.c 
MEDmeshGridIndexCoordinateWr.c 
MEDmeshGridIndexCoordinateRd.c 
MEDmeshGridStructWr.c 
MEDmeshGridStructRd.c 
MEDmeshUniversalNameWr.c 
MEDmeshUniversalNameRd.c 
MEDmeshAttributeWr.c 
MEDmeshAttributeRd.c 
MEDmeshComputationStepCr.c 
MEDmeshComputationStepInfo.c 
MEDmeshComputationStepDtRd.c 
MEDmeshNodeCoordinateWr.c 
MEDmeshNodeCoordinateWithProfileWr.c 
MEDmeshNodeCoordinateAdvancedWr.c 
MEDmeshElementConnectivityAdvancedWr.c 
MEDmeshElementConnectivityWithProfileWr.c 
MEDmeshElementConnectivityWr.c 
MEDmeshNodeCoordinateRd.c 
MEDmeshNodeCoordinateWithProfileRd.c 
MEDmeshNodeCoordinateAdvancedRd.c 
MEDmeshElementConnectivityAdvancedRd.c 
MEDmeshElementConnectivityWithProfileRd.c 
MEDmeshElementConnectivityRd.c 
_MEDmeshnEntity.c 
MEDmeshnEntityWithProfile.c 
MEDmeshnEntity.c 
MEDmeshNodeWr.c 
MEDmeshNodeRd.c 
MEDmeshElementWr.c 
MEDmeshElementRd.c 
MEDfilterAllocate.c 
MEDfilterDeAllocate.c 
MEDfilterClose.c 
_MEDmeshAdvancedWr.c 
_MEDmeshAdvancedRd.c 
MEDmeshEntityNameWr.c 
MEDmeshEntityNumberWr.c 
MEDmeshEntityFamilyNumberWr.c 
MEDmeshEntityNameRd.c 
MEDmeshEntityNumberRd.c 
MEDmeshEntityFamilyNumberRd.c 
MEDmeshnAxis.c 
MEDmeshnAxisByName.c 
MEDmeshPolygonWr.c 
MEDmeshPolygon2Wr.c 
MEDmeshPolygonRd.c 
MEDmeshPolygon2Rd.c 
MEDmeshPolyhedronWr.c 
MEDmeshPolyhedronRd.c 
MEDfamilyCr.c 
MEDnFamily.c 
MEDnFamilyGroup.c 
MEDfamilyInfo.c 
MEDnFamily23Attribute.c 
_MEDnFamily23Attribute236.c 
_MEDnFamily23Attribute30.c 
MEDfamily23Info.c 
_MEDfamily23Info236.c 
_MEDfamily23Info30.c 
_MEDmeshAssociatedGroupCr.c 
MEDmeshSortingTypeRd.c 
MEDnEquivalence.c 
MEDequivalenceCr.c 
MEDequivalenceInfo.c 
MEDequivalenceComputingStepInfo.c 
MEDequivalenceCorrespondenceWr.c 
MEDequivalenceCorrespondenceRd.c 
MEDequivalenceCorrespondenceSizeInfo.c 
MEDequivalenceCorrespondenceSize.c 
MEDsubdomainJointCr.c 
MEDnSubdomainJoint.c 
MEDsubdomainJointInfo.c 
MEDsubdomainCorrespondenceWr.c 
MEDsubdomainComputingStepInfo.c 
MEDsubdomainCorrespondenceSizeInfo.c 
MEDsubdomainCorrespondenceSize.c 
MEDsubdomainCorrespondenceRd.c 
MEDmeshGlobalNumberWr.c 
MEDmeshGlobalNumberRd.c 
MEDstructElementCr.c 
MEDstructElementConstAttWithProfileWr.c 
MEDstructElementConstAttWr.c 
MEDnStructElement.c 
MEDstructElementInfoByName.c 
MEDstructElementInfo.c 
MEDstructElementConstAttInfoByName.c 
MEDstructElementConstAttInfo.c 
MEDstructElementConstAttRd.c 
MEDstructElementAttSizeof.c  
MEDstructElementVarAttCr.c 
MEDstructElementVarAttInfoByName.c 
MEDstructElementVarAttInfo.c 
MEDmeshStructElementVarAttWr.c 
MEDmeshStructElementVarAttRd.c 
MEDstructElementName.c 
MEDstructElementGeotype.c 
_MEDmeshDatagroupOpen.c 
MEDparameterCr.c 
MEDnParameter.c 
MEDparameterInfo.c 
MEDparameterInfoByName.c 
MEDparameterValueWr.c 
MEDparameterValueRd.c 
MEDparameterComputationStepInfo.c 
MEDmeshEntityInfo.c
_MEDfieldCr31.c 
_MEDfieldCr30.c 
_MEDmeshInfoByName30.c 
_MEDmeshnAxisByName30.c 
_MEDmeshUniversalNameRd30.c 
_MEDmeshnEntity30.c 
_MEDmeshInfoByName236.c 
_MEDmeshnAxisByName236.c 
_MEDmeshUniversalNameRd236.c 
_MEDmeshnEntity236.c 
_MEDmeshAdvancedRd30.c 
_MEDmeshAdvancedRd236.c 
_MEDfilterEntityCr30.c 
_MEDfilterEntityCr236.c 
_MEDnFamily30.c 
_MEDnFamily236.c 
_MEDnFamilyGroup30.c 
_MEDnFamilyGroup236.c 
_MEDlinkRd30.c 
_MEDlinkRd236.c 
_MEDfieldComputingStepInfo30.c 
_MEDfieldComputingStepInfo31.c 
_MEDfieldComputingStepInfo236.c 
_MEDfieldComputingStepMeshInfo30.c 
_MEDfieldComputingStepMeshInfo31.c 
_MEDfieldComputingStepMeshInfo236.c 
_MEDfieldComputingStepCheck236.c 
_MEDfieldInfoByName30.c 
_MEDfieldInfoByName236.c 
_MEDfieldnProfile30.c 
_MEDfieldnProfile236.c 
_MEDfieldnValue30.c 
_MEDfieldnValue236.c 
_MEDprofileRd30.c 
_MEDprofileRd236.c 
_MEDlocalizationRd30.c 
_MEDlocalizationRd236.c 
_MEDlocalizationInfoByName30.c 
_MEDlocalizationInfoByName236.c 
_MEDnEquivalence30.c 
_MEDnEquivalence236.c 
_MEDequivalenceInfo30.c 
_MEDequivalenceInfo236.c 
_MEDequivalenceCorrespondenceSize30.c 
_MEDequivalenceCorrespondenceSize236.c 
_MEDequivalenceCorrespondenceWr33.c 
_MEDequivalenceCorrespondenceWr30.c 
_MEDequivalenceCorrespondenceRd33.c 
_MEDequivalenceCorrespondenceRd30.c 
_MEDequivalenceCorrespondenceRd236.c 
_MEDequivalenceComputingStepInfo30.c 
_MEDequivalenceComputingStepInfo236.c 
_MEDequivalenceCorrespondenceSizeInfo30.c 
_MEDequivalenceCorrespondenceSizeInfo236.c 
_MEDmeshComputationStepInfo30.c 
_MEDmeshComputationStepInfo236.c 
_MEDmeshGridIndexCoordinateRd30.c 
_MEDmeshGridIndexCoordinateRd236.c 
_MEDnSubdomainJoint30.c 
_MEDnSubdomainJoint236.c 
_MEDsubdomainJointInfo30.c 
_MEDsubdomainJointInfo236.c 
_MEDsubdomainCorrespondenceSize30.c 
_MEDsubdomainCorrespondenceSize236.c 
_MEDsubdomainCorrespondenceRd30.c 
_MEDsubdomainCorrespondenceRd236.c 
_MEDsubdomainComputingStepInfo30.c 
_MEDsubdomainComputingStepInfo236.c 
_MEDsubdomainCorrespondenceSizeInfo30.c 
_MEDsubdomainCorrespondenceSizeInfo236.c 
_MEDparameterInfoByName30.c 
_MEDparameterInfoByName236.c 
_MEDparameterValueRd30.c 
_MEDparameterValueRd236.c 
_MEDfileCommentRd30.c 
_MEDfileCommentRd236.c 
_MEDfileObjectsMount30.c 
_MEDfileObjectsMount236.c 
_MEDfileObjectsUnmount30.c 
_MEDfileObjectsUnmount236.c 
_MEDfield23ComputingStepMeshInfo30.c 
_MEDfield23ComputingStepMeshInfo31.c 
_MEDfield23ComputingStepMeshInfo236.c 
_MEDfield23nProfile30.c 
_MEDfield23nProfile236.c 
MEDfield23nValueWithProfile.c 
MEDfield23ComputingStepMeshInfo.c 
MEDfield23nProfile.c 
MEDfield23ValueWithProfileRd.c 
_MEDfield23nValue.c 
_MEDfield23nValue30.c 
_MEDfield23nValue236.c 
_MEDmeshEntityInfo30.c 
_MEDmeshEntityInfo236.c
_MEDfamilyInfo32.c
_MEDnFamilyGroup32.c
_MEDfamilyCr30.c
_MEDfamilyCr32.c
_MEDfamilyInfo30.c
_MEDfieldValueAdvancedWr41.c 
MEDfieldEntityType.c 
_MEDfieldEntityType41.c 
MEDfieldnEntityType.c 
_MEDfieldnEntityType41.c 
_MEDfieldnGeometryType41.c 
MEDfieldnGeometryType.c 
_MEDfieldGeometryType41.c 
MEDfieldGeometryType.c  )

IF(MEDFILE_USE_MPI)
  LIST(APPEND ci_SOURCES MEDparFileOpen.c)
ENDIF(MEDFILE_USE_MPI)

# Intermediary targets
ADD_LIBRARY(_ci OBJECT ${ci_SOURCES})

ADD_LIBRARY(_ci_static OBJECT ${ci_SOURCES})
MED_SET_DEFINITIONS(_ci_static MED3_USESTATIC)

=== src/fi/CMakeLists.txt ===
SET(fi_SOURCES
  medsupport.f
  medequivalence.f
  medlink.f
  medinterp.f
  medstructelement.f
  medfilter.f
  medfile.f
  medlocalization.f
  medprofile.f
  medjoint.f
  medparameter.f
  medfamily.f
  medfield.f
  medflibrary.f
  medmesh.f
)

IF(MEDFILE_USE_MPI)
LIST(APPEND fi_SOURCES medparfile.f)
ENDIF(MEDFILE_USE_MPI)

ADD_LIBRARY(_fi        OBJECT ${fi_SOURCES})

=== src/misc/CMakeLists.txt ===
SET(misc_SOURCES
  _MEDaccess.c 
  MEDsetFilter.c
  MEDcstring.c
  MED1cstring.c
  MED2cstring.c
  MEDcstringFree.c
  MEDfstring.c
  _MEDc2fString.c
  MEDexitIf.c
  MEDversionedApi3.cxx
  MEDgetGeometryTypeFromIname.cxx
  MEDversionedApi3C.c
  MEDmodeAcces.cxx
  MEDmodeAccesC.c
  MEDerreur.cxx
  MEDfieldChecked.cxx
  MEDfileVersion.cxx
  _MEDgetGeometricParameter.c
  _MEDgetDynGeometricParameter.c
  _MEDgetDatasetName.c
  _MEDgetDatasetParameter.c
  _MEDgetDatatype.c
  _MEDmeshtypeCompatibility.c
  _MEDgetEntityTypeName.c
  _MEDgetFieldEntityGeoTypeName.c
  _MEDgetInternalGeometryTypeName.c
  _MEDgetInternalGeometryTypeName30.c
  _MEDgetInternalGeometryTypeName33.c
  _MEDgetExternalGeometryTypeName.c
  _MEDcheckVersion30.c
  _MED23v30stringConvert.c
  _MEDgetSupportMeshNbOfEntities.c
  MEDlogicalOp.cxx
  _MEDgetEntityListAttributeIName.c	
 )
  
ADD_LIBRARY(_misc OBJECT ${misc_SOURCES})

ADD_LIBRARY(_misc_static OBJECT ${misc_SOURCES})
MED_SET_DEFINITIONS(_misc_static MED3_USESTATIC)

=== tests/python/CMakeLists.txt ===
SET(_tst_scripts
  # Il faudrait gérer les différents test10_ avec
  # les fichiers paramètres.
  # test10.py
  # test11.py
  test12.py
  test13.py
  test1.py
  test21.py
  test22.py
  test23.py
  test24.py
  test27.py
  test28.py
  test29.py
  test30.py
  test2.py
  test3.py
  test4.py
  test5.py
  test6.py
  test7.py
  test8.py
  test9.py
  test_medfile.py
  test_medmesh.py
)

SET(_to_install
  ${_tst_scripts}
  UseCase_MEDinterp_1.py
  UseCase_MEDinterp_2.py
  UseCase_MEDinterp_3.py
)

FOREACH(_s IN LISTS _tst_scripts)
  STRING(REPLACE ".py" "_Python" _tst_name ${_s})
  FILE(COPY ${_s} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  ADD_TEST(NAME ${_tst_name}
           COMMAND "/usr/bin/env" "PYTHONPATH=${PROJECT_BINARY_DIR}/python" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}/${_s}")
ENDFOREACH()

INSTALL(FILES ${_to_install} DESTINATION bin/testpy)

=== debian/changelog ===
med-fichier (4.1.0+repack-6) unstable; urgency=medium

  * Fix wrong bug number in previous changelog

 -- Gilles Filippini <pini@debian.org>  Tue, 03 Sep 2024 21:33:54 +0200

med-fichier (4.1.0+repack-5) unstable; urgency=medium

  * Fix autopkgtest when default MPI is MPICH (closes: #1080197)
  * New patch hdf5-1.14.patch to allow building against HDF5 1.14
  * Add -DH5_USE_110_API to CPPFLAGS to keep using the HDF5 1.10 API

 -- Gilles Filippini <pini@debian.org>  Mon, 02 Sep 2024 22:47:55 +0200

med-fichier (4.1.0+repack-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064244

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 19:51:14 +0000

med-fichier (4.1.0+repack-4) unstable; urgency=medium

  * Fix openmpi include dirs (closes: #1052753)
  * New patch: fix-stack-smashing-in-test.patch
    Fix a stash smashing error in a unit test

 -- Gilles Filippini <pini@debian.org>  Fri, 29 Sep 2023 20:43:42 +0200

med-fichier (4.1.0+repack-3) unstable; urgency=medium

  * New patch check_hdf5.patch to fix HDF5 version checking (Closes:
    #997351)

 -- Gilles Filippini <pini@debian.org>  Tue, 26 Oct 2021 00:03:04 +0200

=== debian/control ===
Source: med-fichier
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
           "Adam C. Powell, IV" <hazelsct@debian.org>,
           Gilles Filippini <pini@debian.org>
Section: libs
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11),
               gfortran,
               hdf5-tools (>= 1.10.2),
               libhdf5-mpi-dev (>= 1.10.2),
               mpi-default-dev,
               mpi-default-bin,
               libtool,
               tk,
               dh-python,
               python3-all,
               libpython3-all-dev,
               swig
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/med-fichier
Vcs-Git: https://salsa.debian.org/science-team/med-fichier.git
Homepage: http://www.salome-platform.org/user-section/about/med
Testsuite: autopkgtest-pkg-python

Package: libmed-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmed11 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmed
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.

Package: libmed-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the MED-fichier library
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package provides the documentation for the MED-fichier library
 (in French).

Package: libmed-tools
Architecture: any
Multi-Arch: foreign
Section: science
Depends: tk,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Runtime tools to handle MED files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains runtime tools for med-fichier:
  - mdump: a tool to dump MED files
  - xmdump: graphical version of mdump.
  - medconforme: a tool to validate a MED file
  - medimport: a tool to convert a MED v2.1 or v2.2 file into a MED v2.3
    file

Package: libmed11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmed1, libmed1v5 (= 4.0.0+repack-1)
Replaces: libmed1, libmed1v5 (= 4.0.0+repack-1)
Description: Library to exchange meshed data (Fortran version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (Fortran version).

Package: libmedc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhdf5-mpi-dev,
         libmedc11t64 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmedc
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedC.

Package: libmedc11t64
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedc11 (<< ${source:Version}), libmedc1, libmedc1v5 (= 4.0.0+repack-1)
Replaces: libmedc11, libmedc1, libmedc1v5 (= 4.0.0+repack-1)
Description: Library to exchange meshed data (C version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (C version).

Package: libmedimport-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmedc-dev,
         libmedimport0v5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: libmedimportcxx-dev
Description: Development files for libmedimport0
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedimport, including C++ applications.

Package: libmedimport0v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: libmedc11t64,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedimport0
Replaces: libmedimport0
Description: Library to import old version files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the library able to import old version files (C
 version).

Package: python3-med
Architecture: any
Section: python
depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Description: python3 API for MED-fichier
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the Python3 API.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python3

# Which MPI implementation?
# set ARCH_DEFAULT_MPI_IMPL
include /usr/share/mpi-default-dev/debian_defaults

export OMPI_MCA_orte_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
export DEB_CPPFLAGS_MAINT_APPEND := $(filter -I%,$(shell mpicc.$(ARCH_DEFAULT_MPI_IMPL) -show)) -DOMPI_SKIP_MPICXX=1 -DMPICH_SKIP_MPICXX=1 -DH5_USE_110_API
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

# Workaround for FTBFS with GCC-10:
# Error: Type mismatch between actual argument at (1) and actual argument at (2)
export DEB_FFLAGS_MAINT_APPEND := -fallow-argument-mismatch

CONFIGURE_FLAGS = --enable-python --with-swig=yes --with-hdf5=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/$(ARCH_DEFAULT_MPI_IMPL) --with-hdf5-bin=/usr/bin

PY3VERS=$(shell py3versions -vr)
PY3DEF=$(shell py3versions -dv)

override_dh_auto_clean:
	[ ! -f doc/html.dox/Makefile ] || make -C doc/html.dox maintainer-clean-local
	dh_auto_clean
	rm -fr build.* debian/tmp.*
	[ ! -f doc/dox/examples.dox.orig ] || mv doc/dox/examples.dox.orig doc/dox/examples.dox

my_configure_common:
	cp doc/dox/examples.dox doc/dox/examples.dox.orig

my_configure_python%: pyver=$(patsubst my_configure_python%,%,$@)
my_configure_python%: my_configure_common
	PYTHON=/usr/bin/python$(pyver) dh_auto_configure -Bbuild.python$(pyver) -- $(CONFIGURE_FLAGS)

override_dh_auto_configure: $(foreach pyver,$(PY3VERS), my_configure_python$(pyver))

my_build_python%: pyver=$(patsubst my_build_python%,%,$@)
my_build_python%:
	dh_auto_build -Bbuild.python$(pyver)

override_dh_auto_build-arch: $(foreach pyver,$(PY3VERS), my_build_python$(pyver))

override_dh_auto_build-indep:
	dh_auto_build -Bbuild.python$(PY3DEF)/doc/html.dox -- html-local

my_install_python%: pyver=$(patsubst my_install_python%,%,$@)
my_install_python%:
	dh_auto_install -Bbuild.python$(pyver)

override_dh_auto_install-arch: $(foreach pyver,$(PY3VERS), my_install_python$(pyver))
	find debian/tmp/usr/lib/python* \( -name \*.py[co] -o -name \*.la \) -delete
	rm -rf debian/tmp/usr/bin/test* \
	       debian/tmp/usr/bin/usescases \
	       debian/tmp/usr/bin/unittests

override_dh_auto_install-indep:
	dh_auto_install -Bbuild.python$(PY3DEF)/doc/html.dox

override_dh_install:
	dh_install
	rm -f debian/libmedc-dev/usr/include/*import*

define my_auto_test
# $(1): folder to launch the tests from
	MPIEXEC="mpiexec --allow-run-as-root --oversubscribe -np " dh_auto_test -B$(1) --max-parallel=1
endef

override_dh_auto_test-arch:
	# first launch all the tests from the default python3 version's build dir
	$(call my_auto_test,build.python$(PY3DEF))
	# then launch the python tests only from the tests/python subdir of each of the other python3 versions' build dir
	$(foreach pyver,$(filter-out $(PY3DEF),$(PY3VERS)),$(call my_auto_test,build.python$(pyver)/tests/python))

override_dh_auto_test-indep:
